## nodejs 12.7.0~dfsg

=== Makefile ===
-include config.mk

BUILDTYPE ?= Release
PYTHON ?= python
DESTDIR ?=
SIGN ?=
PREFIX ?= /usr/local
FLAKY_TESTS ?= run
TEST_CI_ARGS ?=
STAGINGSERVER ?= node-www
LOGLEVEL ?= silent
OSTYPE := $(shell uname -s | tr '[A-Z]' '[a-z]')
COVTESTS ?= test-cov
COV_SKIP_TESTS ?= core_line_numbers.js,testFinalizer.js,test_function/test.js
GTEST_FILTER ?= "*"
GNUMAKEFLAGS += --no-print-directory
GCOV ?= gcov
PWD = $(CURDIR)
BUILD_WITH ?= make

ifdef JOBS
  PARALLEL_ARGS = -j $(JOBS)
else
  PARALLEL_ARGS = -J
endif

ifdef ENABLE_V8_TAP
  TAP_V8 := --junitout $(PWD)/v8-tap.xml
  TAP_V8_INTL := --junitout $(PWD)/v8-intl-tap.xml
  TAP_V8_BENCHMARKS := --junitout $(PWD)/v8-benchmarks-tap.xml
endif

V8_TEST_OPTIONS = $(V8_EXTRA_TEST_OPTIONS)
ifdef DISABLE_V8_I18N
  V8_BUILD_OPTIONS += i18nsupport=off
endif

ifeq ($(OSTYPE), darwin)
  GCOV = xcrun llvm-cov gcov
endif

BUILDTYPE_LOWER := $(shell echo $(BUILDTYPE) | tr '[A-Z]' '[a-z]')

# Determine EXEEXT
EXEEXT := $(shell $(PYTHON) -c \
		"import sys; print('.exe' if sys.platform == 'win32' else '')")

NODE_EXE = node$(EXEEXT)
NODE ?= ./$(NODE_EXE)
NODE_G_EXE = node_g$(EXEEXT)
NPM ?= ./deps/npm/bin/npm-cli.js

# Flags for packaging.
BUILD_DOWNLOAD_FLAGS ?= --download=all
BUILD_INTL_FLAGS ?= --with-intl=small-icu
BUILD_RELEASE_FLAGS ?= $(BUILD_DOWNLOAD_FLAGS) $(BUILD_INTL_FLAGS)

# Default to quiet/pretty builds.
# To do verbose builds, run `make V=1` or set the V environment variable.
V ?= 0

# Use -e to double check in case it's a broken link
# Use $(PWD) so we can cd to anywhere before calling this
available-node = \
  if [ -x $(PWD)/$(NODE) ] && [ -e $(PWD)/$(NODE) ]; then \
		$(PWD)/$(NODE) $(1); \
	elif [ -x `which node` ] && [ -e `which node` ] && [ `which node` ]; then \
		`which node` $(1); \
	else \
		echo "No available node, cannot run \"node $(1)\""; \
		exit 1; \
	fi;

.PHONY: all
# BUILDTYPE=Debug builds both release and debug builds. If you want to compile
# just the debug build, run `make -C out BUILDTYPE=Debug` instead.
ifeq ($(BUILDTYPE),Release)
all: $(NODE_EXE) ## Default target, builds node in out/Release/node.
else
all: $(NODE_EXE) $(NODE_G_EXE)
endif

.PHONY: help
# To add a target to the help, add a double comment (##) on the target line.
help: ## Print help for targets with comments.
	@printf "For more targets and info see the comments in the Makefile.\n\n"
	@grep -E '^[a-zA-Z0-9._-]+:.*?## .*$$' Makefile | sort | \
		awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-15s\033[0m %s\n", $$1, $$2}'

# The .PHONY is needed to ensure that we recursively use the out/Makefile
# to check for changes.
.PHONY: $(NODE_EXE) $(NODE_G_EXE)

# The -r/-L check stops it recreating the link if it is already in place,
# otherwise $(NODE_EXE) being a .PHONY target means it is always re-run.
# Without the check there is a race condition between the link being deleted
# and recreated which can break the addons build when running test-ci
# See comments on the build-addons target for some more info
ifeq ($(BUILD_WITH), make)
$(NODE_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=Release V=$(V)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Release/$(NODE_EXE) $@; fi

$(NODE_G_EXE): config.gypi out/Makefile
	$(MAKE) -C out BUILDTYPE=Debug V=$(V)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Debug/$(NODE_EXE) $@; fi
else
ifeq ($(BUILD_WITH), ninja)
ifeq ($(V),1)
  NINJA_ARGS := $(NINJA_ARGS) -v
endif
ifdef JOBS
  NINJA_ARGS := $(NINJA_ARGS) -j$(JOBS)
else
  NINJA_ARGS := $(NINJA_ARGS) $(filter -j%,$(MAKEFLAGS))
endif
$(NODE_EXE): config.gypi out/Release/build.ninja
	ninja -C out/Release $(NINJA_ARGS)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Release/$(NODE_EXE) $@; fi

$(NODE_G_EXE): config.gypi out/Debug/build.ninja
	ninja -C out/Debug $(NINJA_ARGS)
	if [ ! -r $@ -o ! -L $@ ]; then ln -fs out/Debug/$(NODE_EXE) $@; fi
else
$(NODE_EXE) $(NODE_G_EXE):
	echo This Makefile currently only supports building with 'make' or 'ninja'
endif
endif


ifeq ($(BUILDTYPE),Debug)
CONFIG_FLAGS += --debug
endif

.PHONY: with-code-cache
with-code-cache:
	echo "'with-code-cache' target is a noop"

.PHONY: test-code-cache
test-code-cache: with-code-cache
	echo "'test-code-cache' target is a noop"

out/Makefile: config.gypi common.gypi node.gyp \
  deps/uv/uv.gyp deps/http_parser/http_parser.gyp deps/zlib/zlib.gyp \
  tools/v8_gypfiles/toolchain.gypi tools/v8_gypfiles/features.gypi \
  tools/v8_gypfiles/inspector.gypi tools/v8_gypfiles/v8.gyp
	$(PYTHON) tools/gyp_node.py -f make

config.gypi: configure configure.py
	@if [ -x config.status ]; then \
		./config.status; \
	else \
		echo Missing or stale $@, please run ./$<; \
		exit 1; \
	fi

.PHONY: install
install: all ## Installs node into $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

.PHONY: uninstall
uninstall: ## Uninstalls node from $PREFIX (default=/usr/local).
	$(PYTHON) tools/install.py $@ '$(DESTDIR)' '$(PREFIX)'

.PHONY: clean
clean: ## Remove build artifacts.
	$(RM) -r out/Makefile $(NODE_EXE) $(NODE_G_EXE) out/$(BUILDTYPE)/$(NODE_EXE) \
		out/$(BUILDTYPE)/node.exp
	@if [ -d out ]; then find out/ -name '*.o' -o -name '*.a' -o -name '*.d' | xargs $(RM) -r; fi
	$(RM) -r node_modules
	@if [ -d deps/icu ]; then echo deleting deps/icu; $(RM) -r deps/icu; fi
	$(RM) test.tap
	# Next one is legacy remove this at some point
	$(RM) -r test/tmp*
	$(RM) -r test/.tmp*
	$(MAKE) test-addons-clean
	$(MAKE) bench-addons-clean

.PHONY: distclean
distclean:
	$(RM) -r out
	$(RM) config.gypi icu_config.gypi config_fips.gypi
	$(RM) config.mk
	$(RM) -r $(NODE_EXE) $(NODE_G_EXE)
	$(RM) -r node_modules
	$(RM) -r deps/icu
	$(RM) -r deps/icu4c*.tgz deps/icu4c*.zip deps/icu-tmp
	$(RM) $(BINARYTAR).* $(TARBALL).*

.PHONY: check
check: test

.PHONY: coverage-clean
# Remove files generated by running coverage, put the non-instrumented lib back
# in place
coverage-clean:
	if [ -d lib_ ]; then $(RM) -r lib; mv lib_ lib; fi
	$(RM) -r node_modules
	$(RM) -r gcovr build
	$(RM) -r out/$(BUILDTYPE)/.coverage
	$(RM) out/$(BUILDTYPE)/obj.target/node/gen/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/tracing/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/gen/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/tracing/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/cctest/src/*.gcno
	$(RM) out/$(BUILDTYPE)/obj.target/cctest/test/cctest/*.gcno

.PHONY: coverage
# Build and test with code coverage reporting.  Leave the lib directory
# instrumented for any additional runs the user may want to make.
# For C++ coverage reporting, this needs to be run in conjunction with configure
#  --coverage.  html coverage reports will be created under coverage/
# Related CI job: node-test-commit-linux-coverage
coverage: coverage-test ## Run the tests and generate a coverage report.

.PHONY: coverage-build
coverage-build: all
	-$(MAKE) coverage-build-js
	if [ ! -d gcovr ]; then git clone -b 3.4 --depth=1 \
		--single-branch https://github.com/gcovr/gcovr.git; fi
	if [ ! -d build ]; then git clone --depth=1 \
		--single-branch https://github.com/nodejs/build.git; fi
	if [ ! -f gcovr/scripts/gcovr.orig ]; then \
		(cd gcovr && patch -N -p1 < \
		"$(CURDIR)/build/jenkins/scripts/coverage/gcovr-patches-3.4.diff"); fi
	$(MAKE)

.PHONY: coverage-build-js
coverage-build-js:
	mkdir -p node_modules
	if [ ! -d node_modules/c8 ]; then \
		$(NODE) ./deps/npm install c8 --no-save --no-package-lock;\
	fi

.PHONY: coverage-test
coverage-test: coverage-build
	$(RM) out/$(BUILDTYPE)/obj.target/node/gen/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node/src/tracing/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node_lib/gen/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node_lib/src/*.gcda
	$(RM) out/$(BUILDTYPE)/obj.target/node_lib/src/tracing/*.gcda
	-NODE_V8_COVERAGE=out/$(BUILDTYPE)/.coverage \
                TEST_CI_ARGS="$(TEST_CI_ARGS) --type=coverage" $(MAKE) $(COVTESTS)
	$(MAKE) coverage-report-js
	-(cd out && "../gcovr/scripts/gcovr" --gcov-exclude='.*deps' \
		--gcov-exclude='.*usr' -v -r Release/obj.target \
		--html --html-detail -o ../coverage/cxxcoverage.html \
		--gcov-executable="$(GCOV)")
	@echo -n "Javascript coverage %: "
	@grep -B1 Lines coverage/index.html | head -n1 \
		| sed 's/<[^>]*>//g'| sed 's/ //g'
	@echo -n "C++ coverage %: "
	@grep -A3 Lines coverage/cxxcoverage.html | grep style  \
		| sed 's/<[^>]*>//g'| sed 's/ //g'

COV_REPORT_OPTIONS = --reporter=html \
	--temp-directory=out/$(BUILDTYPE)/.coverage --omit-relative=false \
	--resolve=./lib --exclude="benchmark/" --exclude="deps/" --exclude="test/" --exclude="tools/" \
	--wrapper-length=0
ifdef COV_ENFORCE_THRESHOLD
  COV_REPORT_OPTIONS += --check-coverage --lines=$(COV_ENFORCE_THRESHOLD)
endif

.PHONY: coverage-report-js
coverage-report-js:
	$(NODE) ./node_modules/.bin/c8 report $(COV_REPORT_OPTIONS)

.PHONY: cctest
# Runs the C++ tests using the built `cctest` executable.
cctest: all
	@out/$(BUILDTYPE)/$@ --gtest_filter=$(GTEST_FILTER)

.PHONY: list-gtests
list-gtests:
ifeq (,$(wildcard out/$(BUILDTYPE)/cctest))
	$(error Please run 'make cctest' first)
endif
	@out/$(BUILDTYPE)/cctest --gtest_list_tests

.PHONY: v8
# Related CI job: node-test-commit-v8-linux
# Rebuilds deps/v8 as a git tree, pulls its third-party dependencies, and
# builds it.
v8:
	tools/make-v8.sh $(V8_ARCH).$(BUILDTYPE_LOWER) $(V8_BUILD_OPTIONS)

.PHONY: jstest
jstest: build-addons build-js-native-api-tests build-node-api-tests ## Runs addon tests and JS tests
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) \
		--skip-tests=$(CI_SKIP_TESTS) \
		$(CI_JS_SUITES) \
		$(CI_NATIVE_SUITES)

.PHONY: coverage-run-js
coverage-run-js:
	$(RM) -r out/$(BUILDTYPE)/.coverage
	$(MAKE) coverage-build-js
	-NODE_V8_COVERAGE=out/$(BUILDTYPE)/.coverage CI_SKIP_TESTS=$(COV_SKIP_TESTS) \
	        TEST_CI_ARGS="$(TEST_CI_ARGS) --type=coverage" $(MAKE) jstest
	$(MAKE) coverage-report-js

.PHONY: test
# This does not run tests of third-party libraries inside deps.
test: all ## Runs default tests, linters, and builds docs.
	$(MAKE) -s test-doc
	$(MAKE) -s build-addons
	$(MAKE) -s build-js-native-api-tests
	$(MAKE) -s build-node-api-tests
	$(MAKE) -s cctest
	$(MAKE) -s jstest

.PHONY: test-only
test-only: all  ## For a quick test, does not run linter or build docs.
	$(MAKE) build-addons
	$(MAKE) build-js-native-api-tests
	$(MAKE) build-node-api-tests
	$(MAKE) cctest
	$(MAKE) jstest

# Used by `make coverage-test`
test-cov: all
	$(MAKE) build-addons
	$(MAKE) build-js-native-api-tests
	$(MAKE) build-node-api-tests
	# $(MAKE) cctest
	CI_SKIP_TESTS=$(COV_SKIP_TESTS) $(MAKE) jstest

test-parallel: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) parallel

test-valgrind: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --valgrind sequential parallel message

test-check-deopts: all
	$(PYTHON) tools/test.py $(PARALLEL_ARGS) --mode=$(BUILDTYPE_LOWER) --check-deopts parallel sequential

benchmark/napi/function_call/build/$(BUILDTYPE)/binding.node: \
		benchmark/napi/function_call/napi_binding.c \
		benchmark/napi/function_call/binding.cc \
		benchmark/napi/function_call/binding.gyp | all
	$(NODE) deps/npm/node_modules/node-gyp/bin/node-gyp rebuild \
		--python="$(PYTHON)" \
		--directory="$(shell pwd)/benchmark/napi/function_call" \
		--nodedir="$(shell pwd)"

benchmark/napi/function_args/build/$(BUILDTYPE)/binding.node: \
		benchmark/napi/function_args/napi_binding.c \
		benchmark/napi/function_args/binding.cc \
		benchmark/napi/function_args/binding.gyp | all
	$(NODE) deps/npm/node_modules/node-gyp/bin/node-gyp rebuild \
		--python="$(PYTHON)" \
		--directory="$(shell pwd)/benchmark/napi/function_args" \
		--nodedir="$(shell pwd)"

DOCBUILDSTAMP_PREREQS = tools/doc/addon-verify.js doc/api/addons.md

ifeq ($(OSTYPE),aix)
DOCBUILDSTAMP_PREREQS := $(DOCBUILDSTAMP_PREREQS) out/$(BUILDTYPE)/node.exp
endif

=== deps/openssl/config/Makefile ===
# This Makefile is confirmed to be run only on Linux (CentOS and
# Ubuntu). perl5 and gas(>=2.26) are needed.

UNAME_S := $(shell uname -s)
ifneq ($(UNAME_S),Linux)
  $(error This can be run only on Linux)
endif

PERL    = perl

# Supported architecture list
ASM_ARCHS = aix-gcc aix64-gcc BSD-x86_64 \
darwin64-x86_64-cc darwin-i386-cc linux-aarch64 \
linux-armv4 linux-elf linux-x32 linux-x86_64 linux-ppc \
linux-ppc64 linux-ppc64le linux32-s390x linux64-s390x linux64-mips64\
solaris-x86-gcc solaris64-x86_64-gcc VC-WIN64A VC-WIN32

NO_ASM_ARCHS = VC-WIN64-ARM

CC = gcc
FAKE_GCC = ../config/fake_gcc.pl

CONFIGURE = ./Configure
# no-comp: against CRIME attack
# no-shared: openssl-cli needs static link
# no-afalgeng: old Linux kernel < 4.0 does not support it
# enable-ssl-trace: cause the optional SSL_trace API to be built
COPTS =  no-comp no-shared no-afalgeng enable-ssl-trace

# disable platform check in Configure
NO_WARN_ENV = CONFIGURE_CHECKER_WARN=1

GENERATE = ./generate_gypi.pl

OPSSL_SRC = ../openssl

# Header files generated with Configure
CFG = opensslconf.h
SRC_CFG = $(OPSSL_SRC)/include/openssl/$(CFG)
INT_CFGS = bn_conf.h dso_conf.h
INT_CFG_DIR = $(OPSSL_SRC)/crypto/include/internal

PHONY = all clean replace
.PHONY: $(PHONY)

all: $(ASM_ARCHS) $(NO_ASM_ARCHS) replace

# Configure and generate openssl asm files for each archs
$(ASM_ARCHS):
	cd $(OPSSL_SRC); $(NO_WARN_ENV) CC=$(CC) $(PERL) $(CONFIGURE) $(COPTS) $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) asm $@
# Confgure asm_avx2 and generate upto avx2 support
	cd $(OPSSL_SRC); $(NO_WARN_ENV) CC=$(FAKE_GCC) $(PERL) $(CONFIGURE) \
	$(COPTS) $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) asm_avx2 $@
# Configure no-asm and generate no-asm sources
	cd $(OPSSL_SRC); $(NO_WARN_ENV) $(PERL) $(CONFIGURE) $(COPTS) \
	no-asm $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) no-asm $@

$(NO_ASM_ARCHS):
# Configure no-asm and generate no-asm sources
	cd $(OPSSL_SRC); $(NO_WARN_ENV) $(PERL) $(CONFIGURE) $(COPTS) \
	no-asm $@;
	$(PERL) -w -I$(OPSSL_SRC) $(GENERATE) no-asm $@

# Replace and copy arch dependent headers
replace:
	cp ./$(CFG).tmpl $(SRC_CFG)
	@for c in $(INT_CFGS); do \
	    cp ./$$c.tmpl $(INT_CFG_DIR)/$$c; \
	done

clean:
	find archs \( -name \*.S -o -name \*.s -o -name \*.asm -o \
	-name \*.gypi -o -name \*.h -o -name \*.pm -o -name \*.rc \) -exec rm "{}" \;

=== debian/changelog ===
nodejs (12.7.0~dfsg-1) experimental; urgency=medium

  * New upstream version 12.7.0~dfsg (Closes: #932991)
  * Use shared libuv >= 1.30.1
  * Build-Depends node-debbundle-acorn >= 6.1.0~
  * Build-Depends libnghttp2-dev >= 1.39.1
  * Tighten dependency on icu >= 64.0~
  * rules: set nghttp2 lib name - upstream assumes lib prefix
  * Upstream patch to fix linking against libnode
  * Build with snapshot https://github.com/nodejs/node/issues/28675

 -- Jérémy Lal <kapouer@melix.org>  Sat, 03 Aug 2019 19:48:03 +0200

nodejs (12.2.0~dfsg-1) experimental; urgency=medium

  * New upstream version 12.2.0~dfsg

 -- Jérémy Lal <kapouer@melix.org>  Tue, 07 May 2019 21:39:23 +0200

=== debian/control ===
Source: nodejs
Section: javascript
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs,
 debhelper (>=9.20160114),
 dh-buildinfo,
 pkg-config,
 bash-completion,
 libkvm-dev [kfreebsd-any],
 gyp (>= 0.1~svn1773),
 openssl (>= 1.1.1~),
 zlib1g-dev,
 libicu-dev (>= 64.0~),
 libc-ares-dev (>= 1.14~),
 libnghttp2-dev (>= 1.39.1~),
 curl,
 procps,
 node-debbundle-acorn (>= 6.1.0~),
 ca-certificates,
 python,
 libssl-dev (>= 1.1.1~),
 libuv1-dev (>= 1.30.1~)
Build-Depends-Indep: node-js-yaml,
 node-marked
Standards-Version: 4.3.0
Homepage: http://nodejs.org/
Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-12.x
Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-12.x

Package: libnode-dev
Section: libdevel
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: same
Depends: ${cdbs:Depends},
 ${misc:Depends},
 libnode72 (= ${binary:Version})
Suggests: ${cdbs:Suggests}
Breaks: ${cdbs:Breaks}
Replaces: ${cdbs:Replaces}
Conflicts: ${cdbs:Conflicts}
Provides: ${cdbs:Provides}
Description: evented I/O for V8 javascript (development files)
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 This package provides development headers for libnode__ABI.

Package: nodejs
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libnode72 (= ${binary:Version})
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends},
 nodejs-doc
Suggests: npm
Replaces: nodejs-legacy
Conflicts: nodejs-legacy
Description: evented I/O for V8 javascript - runtime executable
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.

Package: libnode72
Section: libs
Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
Multi-Arch: same
Depends: ${shlibs:Depends},
 ${misc:Depends}
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends}
Breaks: ${cdbs:Breaks}
Replaces: nodejs-legacy
Conflicts: nodejs-legacy
Description: evented I/O for V8 javascript - runtime library
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package provides the dynamic library for Node.js.

Package: nodejs-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Provides: ${cdbs:Provides}
Recommends: ${cdbs:Recommends}, nodejs
Replaces: nodejs (<< 6.11.2~dfsg-3)
Conflicts: nodejs (<< 6.11.2~dfsg-3)
Description: API documentation for Node.js, the javascript platform
 Node.js is a platform built on Chrome's JavaScript runtime for easily
 building fast, scalable network applications. Node.js uses an
 event-driven, non-blocking I/O model that makes it lightweight and
 efficient, perfect for data-intensive real-time applications that run
 across distributed devices.
 .
 Node.js is bundled with several useful libraries to handle server
 tasks:
 .
 System, Events, Standard I/O, Modules, Timers, Child Processes, POSIX,
 HTTP, Multipart Parsing, TCP, DNS, Assert, Path, URL, Query Strings.
 .
 This package contains API documentation for Node.js.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# This needs to run before inclusion of CDBS snippets
debian/control:: debian/control.in debian/watch
DEB_PHONY_RULES += debian/control.in debian/watch
debian/control.in::
	sed $(foreach re,ABI ARCHS BRANCH,-e 's/__$(re)__/$($(re))/g') \
		< debian/control.in.in > debian/control.in

debian/watch::
	sed $(foreach re,BRANCH,-e 's/__$(re)__/$($(re))/g') \
		< debian/watch.in > debian/watch

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

# source equivalent of nodejs -e 'console.log(process.versions.modules)'
ABI = $(shell awk '/^\#define NODE_MODULE_VERSION/ {print $$3}' src/node_version.h)

# archs
ARCHS := amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x

# branch
BRANCH := $(word 1, $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))

# Build-depend unversioned on debhelper
#  TODO: Drop when adopted in cdbs
CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper (>=9.20160114)

# Do not install licensecheck please
CDBS_BUILD_DEPENDS_rules_utils_copyright-check =

# Needed by upstream build
#  * recent gyp needed to build using flock
bdeps = pkg-config, bash-completion, libkvm-dev [kfreebsd-any], gyp (>= 0.1~svn1773)
bdeps +=, openssl (>= 1.1.1~)
bdeps +=, zlib1g-dev
bdeps +=, libicu-dev (>= 64.0~)
bdeps +=, libc-ares-dev (>= 1.14~)
bdeps +=, libnghttp2-dev (>= 1.39.1~)
# bdeps +=, libhttp-parser-dev (>= 2.8~)

# Needed by dev
devdeps = libssl-dev (>= 1.1.1~)
devdeps +=, libuv1-dev (>= 1.30.1~)

# Needed for tests
bdeps +=, curl, procps,
bdeps +=, node-debbundle-acorn (>= 6.1.0~)
bdeps +=, ca-certificates
bdeps +=, python

CDBS_BUILD_DEPENDS +=, $(bdeps), $(deps), $(devdeps)
CDBS_DEPENDS_libnode-dev = $(devdeps)

CDBS_RECOMMENDS_nodejs = ca-certificates
CDBS_BREAKS_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev
CDBS_BREAKS_libnode$(ABI) = node-modern-syslog (<< 1.1.4-2)
CDBS_REPLACES_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev, libv8-dev
CDBS_PROVIDES_libnode-dev = libv8-dev
CDBS_CONFLICTS_libnode-dev = libv8-dev (<= 3.14.5.8-11)
LANG=C
export LANG
DEB_CONFIGURE_NORMAL_ARGS =
DEB_CONFIGURE_EXTRA_FLAGS = \
--without-npm \
--shared \
--shared-zlib \
--shared-cares \
--shared-nghttp2 --shared-nghttp2-libname=nghttp2 \
--with-intl=system-icu \
--prefix=/usr \
--openssl-use-def-ca-store \
--arch-triplet=$(DEB_HOST_MULTIARCH) \
--node-relative-path="lib/$(DEB_HOST_MULTIARCH)/nodejs:share/nodejs:lib/nodejs" \
--shared-libuv

DEB_CONFIGURE_EXTRA_FLAGS += --shared-openssl

# map HOST ARCH AND OS, and if unknown let upstream guess

# ia32 x64 x32 arm arm64 mips mipsel mips64el x87 ppc ppc64
destCpu =
destCpu := $(or $(destCpu),$(if $(filter i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter x32,$(DEB_HOST_ARCH)),x32))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter hurd-i386,$(DEB_HOST_ARCH)),ia32))
destCpu := $(or $(destCpu),$(if $(filter amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter kfreebsd-amd64,$(DEB_HOST_ARCH)),x64))
destCpu := $(or $(destCpu),$(if $(filter armel,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter armhf,$(DEB_HOST_ARCH)),arm))
destCpu := $(or $(destCpu),$(if $(filter aarch64,$(DEB_HOST_ARCH)),arm64))
destCpu := $(or $(destCpu),$(if $(filter mipsel,$(DEB_HOST_ARCH)),mipsel))
destCpu := $(or $(destCpu),$(if $(filter mips64el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips64r6el,$(DEB_HOST_ARCH)),mips64el))
destCpu := $(or $(destCpu),$(if $(filter mips,$(DEB_HOST_ARCH)),mips))
destCpu := $(or $(destCpu),$(if $(filter powerpc,$(DEB_HOST_ARCH)),unsupported))
destCpu := $(or $(destCpu),$(if $(filter ppc64,$(DEB_HOST_ARCH)),ppc64))
destCpu := $(or $(destCpu),$(if $(filter s390x,$(DEB_HOST_ARCH)),s390x))

# solaris freebsd openbsd linux
destOs =
destOs := $(or $(destOs),$(if $(filter linux,$(DEB_HOST_ARCH_OS)),linux))
destOs := $(or $(destOs),$(if $(filter kfreebsd,$(DEB_HOST_ARCH_OS)),freebsd))

ifneq (, $(destOs))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-os=$(destOs)
endif
ifeq (unsupported, $(destCpu))
$(error "nodejs cannot run on $(DEB_HOST_ARCH), please consult maintainers")
endif
ifneq (, $(destCpu))
DEB_CONFIGURE_EXTRA_FLAGS += --dest-cpu=$(destCpu)
endif

ifeq (freebsd, $(destOs))
LDFLAGS += -lbsd
endif

# mips and fpu
# https://github.com/paul99/v8m-rb/issues/192
# https://bugs.debian.org/800410
# mips and big binaries
# http://gcc.gnu.org/wiki/DebugFission
# https://bugs.debian.org/829139

# use r2, which is the supported variant for these architectures
# https://lists.debian.org/debian-mips/2016/07/msg00000.html
ifeq (mipsel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
LDFLAGS += -latomic
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif
ifeq (mips, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
LDFLAGS += -latomic
CFLAGS += -gsplit-dwarf
CPPFLAGS += -gsplit-dwarf
endif

# mips32r1 or greater, detected at runtime
ifeq (mips64el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
endif
ifeq (mips64r6el, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
endif

ifeq (armel, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=softfp
ifeq ($(shell dpkg-vendor --is ubuntu && echo true),true)
# Ubuntu targets armv7+ with VFP and thumb2 support by default for armel
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
else
# debian defaults
# v8 does not support < armv5
CXXFLAGS += -march=armv5t
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
endif
endif

ifeq (armhf, $(DEB_HOST_ARCH))
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-float-abi=hard
ifeq ($(shell dpkg-vendor --derives-from raspbian && echo true),true)
# enable vfp, disable armv7
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfp
else
# enable armv7 vfpv3
DEB_CONFIGURE_EXTRA_FLAGS += --with-arm-fpu=vfpv3
endif
endif

DEB_DESTDIR = $(CURDIR)/debian/tmp
DEB_MAKE_CLEAN_TARGET = clean
ifeq ($(DEB_PARALLEL_JOBS),)
JOBS := 1
else ifeq ($(SCHROOT_USER),"buildd")
JOBS := 1
else
JOBS := $(DEB_PARALLEL_JOBS)
endif
export JOBS
DEB_MAKE_BUILD_TARGET = build

#  relax regression tests when targeted experimental suite
export HOME = $(CURDIR)/tmp
export FLAKY_TESTS = dontcare
export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
export CI_JS_SUITES = message parallel sequential
export NODE_TEST_DIR = $(CURDIR)/tmp
# needed for tests to avoid "ee key too small" errors
export OPENSSL_CONF = ./deps/openssl/openssl/apps/openssl.cnf
# keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -x 'Distribution: \(experimental\|UNRELEASED\)'),-i)
DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js

# build -fPIC
CFLAGS+=-fPIC
CPPFLAGS+=-fPIC
# hardening gyp
CFLAGS+=-g
CPPFLAGS+=-g
CXXFLAGS+=$(CPPFLAGS)
export CPPFLAGS
export CXXFLAGS
export CFLAGS
export LDFLAGS

# disable DNS requests during tests
export RES_OPTIONS = attempts:0

# properly clean files from build, test, python
clean::
	rm -f icu_config.gypi
	rm -rf test/addons/doc-*
	rm -f test/addons/.buildstamp
	rm -f test/addons/.docbuildstamp
	rm -rf test/addons/*/build
	rm -f config.gypi
	rm -f config.mk
	rm -f config.status
	rm -f test/fixtures/hello.txt
	rm -rf $(NODE_TEST_DIR)
	rm -f node_modules
	rm -rf tools/node_modules
	find . -name "*.pyc" -delete
	rm -rf out
	rm -rf deps/acorn/
	rm -f debian/libnode$(ABI).install
	rm -f debian/libnode-dev.links

# remove *.json files from documentation
binary-install/nodejs-doc::
	find debian/nodejs-doc/usr/share/doc/nodejs-doc -name *.json -delete

pre-build::
	ln -sTf /usr/lib/nodejs node_modules

## nodejs 12.18.2~dfsg

=== debian/changelog ===
nodejs (12.18.2~dfsg-1ubuntu2) groovy; urgency=medium

  * debian/patches/3f071e3.patch:
  * debian/patches/1a9c676a141b32483b48884f8cc0330e64c8e17f.patch:
    - cherry-pick two upstream changes in v8 to fix a testsuite failure on
      ppc64el for some sha1 calculation errors (LP: #1887144)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 19 Aug 2020 20:47:23 +0200

nodejs (12.18.2~dfsg-1ubuntu1) groovy; urgency=medium

  * Merge from Debian (LP: #1882185). Remaining changes:
    - debian/control:
      + change python build dependency to python2
    - debian/tests/control: change python test dependency to python2
    - debian/patches/python2.patch: explicitly invoke python2 in tests
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 28 Jul 2020 15:12:12 +0200

nodejs (12.18.2~dfsg-1) unstable; urgency=medium

  * New upstream version 12.18.2~dfsg
  * Drop Breaks: libnode64-dev, package does not exist
  * Drop libnode-dev Depends: nodejs, useless
  * libnode72 breaks libnode64. Closes: #966008

 -- Jérémy Lal <kapouer@melix.org>  Wed, 22 Jul 2020 10:36:58 +0200

nodejs (12.18.1~dfsg-1ubuntu1) groovy; urgency=medium

  * Merge from Debian (LP: #1882185). Remaining changes:
    - debian/control:
      + change python build dependency to python2
    - debian/tests/control: change python test dependency to python2
    - debian/patches/python2.patch: explicitly invoke python2 in tests
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 08 Jul 2020 09:58:55 +0200

nodejs (12.18.1~dfsg-1) unstable; urgency=medium

  * New upstream version 12.18.1~dfsg
  * Update gbp.conf for *-12.x branches
  * Just completely disable ADDRCONFIG flag,
    but skip the two failing tests anyway
  * Multiarch hinter: remove Multi-Arch: same on libnode-dev
  * Patch to fix ppc64 build
  * rules: JOBS=1 on 32-bit only
  * libnode-dev depends nodejs: let addons test all right ?

 -- Jérémy Lal <kapouer@melix.org>  Tue, 30 Jun 2020 19:11:03 +0200

nodejs (12.18.0~dfsg-3ubuntu1) groovy; urgency=medium

  * Merge from Debian (LP: #1882185). Remaining changes:
    - debian/control:
      + change python build dependency to python2
    - debian/tests/control: change python test dependency to python2
    - debian/patches/python2.patch: explicitly invoke python2 in tests
    - debian/patches/test-lowerseclevel.patch: lower SECLEVEL in the
      openssl.cnf used for testing

 -- Olivier Tilloy <olivier.tilloy@canonical.com>  Wed, 17 Jun 2020 17:08:19 +0200

nodejs (12.18.0~dfsg-3) unstable; urgency=medium

  * mipsel does not support a feature leading to test failures
  * Two tests won't pass on IPv6-only hosts

 -- Jérémy Lal <kapouer@melix.org>  Thu, 11 Jun 2020 17:59:38 +0200

nodejs (12.18.0~dfsg-2) unstable; urgency=medium

  * Do not use dns.ADDRCONFIG for localhost

 -- Jérémy Lal <kapouer@melix.org>  Thu, 11 Jun 2020 10:03:21 +0200

nodejs (12.18.0~dfsg-1) experimental; urgency=medium

  * New upstream version 12.18.0~dfsg. Closes: #962145.
  * Security fixes:
    + CVE-2020-11080
    + CVE-2020-8172
    + CVE-2020-8174
  * Build-Depends nghttp2 >= 1.41.0

 -- Jérémy Lal <kapouer@melix.org>  Fri, 05 Jun 2020 09:07:20 +0200

nodejs (12.17.0~dfsg-4) experimental; urgency=medium

  * Fix openssl.cnf path in libnode-dev.install

 -- Jérémy Lal <kapouer@melix.org>  Wed, 03 Jun 2020 09:59:43 +0200

nodejs (12.17.0~dfsg-3) experimental; urgency=medium

  * nodejs-doc: remove placeholder in long desc,
    libnode__ABI is libnode72
  * install missing files:
    + libnode: node.stp systemtap config
    + nodejs: gdbinit, lldb_commands.py
  * move files in better paths (backward-compatibly):
    + usr/include/openssl.cnf to usr/share/doc/nodejs
    + usr/include/v8 links to usr/include/node
  * mips patches:
    + reduce reserved memory for mksnapshot to avoid oom
    + test-cli-node-options skips --jitless

 -- Jérémy Lal <kapouer@melix.org>  Wed, 03 Jun 2020 02:59:20 +0200

nodejs (12.17.0~dfsg-2) experimental; urgency=medium

  * Build with -g1 on 32-bit, else -g
  * Use dh --max-parallel=1 on 32-bit
  * Backport v8 commit to fix mips snapshots
  * Install devel files in /usr/include/node,
    keep the old locations for backward compatibility.
  * Use new alioth-lists email for maintainer
  * nodejs-doc: add misc:Depends
  * Standards-Version 4.5.0, no change required

 -- Jérémy Lal <kapouer@melix.org>  Mon, 01 Jun 2020 15:17:35 +0200

nodejs (12.17.0~dfsg-1) experimental; urgency=medium

  * New upstream version 12.17.0~dfsg
  * Ignore dh_dwz failures
  * Depends sse2-support on i386. Closes: #961621
  * copyright: deps/zlib/doc is no longer bundled
  * Drop icu 67 patch
  * On 32bit archs, save memory with -g1 and --max-parallel=1

 -- Jérémy Lal <kapouer@melix.org>  Fri, 29 May 2020 22:34:25 +0200

nodejs (12.16.3~dfsg-2) experimental; urgency=medium

  * Revert upstream commit, fix test-tls-root-certificates failure

 -- Jérémy Lal <kapouer@melix.org>  Thu, 30 Apr 2020 17:47:19 +0200

nodejs (12.16.3~dfsg-1) experimental; urgency=medium

  * New upstream version 12.16.3~dfsg
  * dh_dwz: set a lower low-mem-die-limit

 -- Jérémy Lal <kapouer@melix.org>  Thu, 30 Apr 2020 00:19:39 +0200

nodejs (12.16.2~dfsg-2) experimental; urgency=medium

  * Fix arch all build: skip tests, make install

 -- Jérémy Lal <kapouer@melix.org>  Sun, 26 Apr 2020 23:28:38 +0200

nodejs (12.16.2~dfsg-1) experimental; urgency=medium

  [ Xavier Guimard ]
  * Add upstream/metadata
  * Disable test-release-npm test
  * Switch to dh, Bump debhelper compatibility level to 12
  * New upstream version 12.16.1~dfsg
  * Refresh patches

  [ Olivier Tilloy ]
  * Fix building architecture-independent doc package
    (Closes: #952629)

  [ Jérémy Lal ]
  * Revert "Override any source-is-missing - workaround pattern issues"


=== debian/control ===
--- 
+++ 
@@ -1,31 +1,34 @@
 Source: nodejs
 Section: javascript
 Priority: optional
-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
+Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@alioth-lists.debian.net>
 Uploaders: Jérémy Lal <kapouer@melix.org>,
  Jonas Smedegaard <dr@jones.dk>
-Build-Depends: cdbs,
- debhelper (>=9.20160114),
+Build-Depends:
+ debhelper-compat (= 12),
  dh-buildinfo,
+ bash-completion,
+ ca-certificates,
+ curl,
+ gyp (>= 0.1~svn1773),
+ libbrotli-dev,
+ libc-ares-dev (>= 1.14~),
+ libhttp-parser-dev (>= 2.9.2~),
+ libicu-dev (>= 64.0~),
+ libkvm-dev [kfreebsd-any],
+ libnghttp2-dev (>= 1.41.0~),
+ libssl-dev (>= 1.1.1~),
+ libuv1-dev (>= 1.33.0~),
+ node-acorn (>= 6.2.1~),
+ openssl (>= 1.1.1~),
  pkg-config,
- bash-completion,
- libkvm-dev [kfreebsd-any],
- gyp (>= 0.1~svn1773),
- openssl (>= 1.1.1~),
+ pkg-js-tools (>= 0.8.2~),
+ python2,
+ procps,
  zlib1g-dev,
- libicu-dev (>= 64.0~),
- libc-ares-dev (>= 1.14~),
- libnghttp2-dev (>= 1.39.1~),
- curl,
- procps,
- node-debbundle-acorn (>= 6.1.0~),
- ca-certificates,
- python,
- libssl-dev (>= 1.1.1~),
- libuv1-dev (>= 1.30.1~)
 Build-Depends-Indep: node-js-yaml,
  node-marked
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: http://nodejs.org/
 Vcs-Browser: https://salsa.debian.org/js-team/nodejs/tree/master-12.x
 Vcs-Git: https://salsa.debian.org/js-team/nodejs.git -b master-12.x
@@ -33,15 +36,15 @@
 Package: libnode-dev
 Section: libdevel
 Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
-Multi-Arch: same
-Depends: ${cdbs:Depends},
- ${misc:Depends},
+Depends: ${misc:Depends},
+ libssl-dev (>= 1.1.1~),
+ libuv1-dev (>= 1.33.0~),
  libnode72 (= ${binary:Version})
-Suggests: ${cdbs:Suggests}
-Breaks: ${cdbs:Breaks}
-Replaces: ${cdbs:Replaces}
-Conflicts: ${cdbs:Conflicts}
-Provides: ${cdbs:Provides}
+Breaks: nodejs-dev (<< 10.0.0~dfsg1-3)
+Replaces: libv8-dev,
+ nodejs-dev (<< 10.0.0~dfsg1-3)
+Conflicts: libv8-dev (<= 3.14.5.8-11)
+Provides: libv8-dev
 Description: evented I/O for V8 javascript (development files)
  Node.js is a platform built on Chrome's JavaScript runtime for easily
  building fast, scalable network applications. Node.js uses an
@@ -49,7 +52,7 @@
  efficient, perfect for data-intensive real-time applications that run
  across distributed devices.
  .
- This package provides development headers for libnode__ABI.
+ This package provides development headers for libnode72
 
 Package: nodejs
 Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
@@ -58,8 +61,7 @@
  ${shlibs:Depends},
  ${misc:Depends},
  libnode72 (= ${binary:Version})
-Provides: ${cdbs:Provides}
-Recommends: ${cdbs:Recommends},
+Recommends: ca-certificates,
  nodejs-doc
 Suggests: npm
 Replaces: nodejs-legacy
@@ -82,10 +84,10 @@
 Architecture: amd64 arm64 armhf i386 kfreebsd-i386 kfreebsd-amd64 mips mips64el mips64r6el mipsel ppc64 ppc64el s390x
 Multi-Arch: same
 Depends: ${shlibs:Depends},
- ${misc:Depends}
-Provides: ${cdbs:Provides}
-Recommends: ${cdbs:Recommends}
-Breaks: ${cdbs:Breaks}
+ ${misc:Depends},
+ sse2-support [i386]
+Breaks: node-modern-syslog (<< 1.1.4-2),
+ libnode64
 Replaces: nodejs-legacy
 Conflicts: nodejs-legacy
 Description: evented I/O for V8 javascript - runtime library
@@ -107,9 +109,8 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
+Recommends: nodejs
 Depends: ${misc:Depends}
-Provides: ${cdbs:Provides}
-Recommends: ${cdbs:Recommends}, nodejs
 Replaces: nodejs (<< 6.11.2~dfsg-3)
 Conflicts: nodejs (<< 6.11.2~dfsg-3)
 Description: API documentation for Node.js, the javascript platform

=== debian/rules ===
--- 
+++ 
@@ -1,21 +1,6 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
-
-# This needs to run before inclusion of CDBS snippets
-debian/control:: debian/control.in debian/watch
-DEB_PHONY_RULES += debian/control.in debian/watch
-debian/control.in::
-	sed $(foreach re,ABI ARCHS BRANCH,-e 's/__$(re)__/$($(re))/g') \
-		< debian/control.in.in > debian/control.in
-
-debian/watch::
-	sed $(foreach re,BRANCH,-e 's/__$(re)__/$($(re))/g') \
-		< debian/watch.in > debian/watch
-
-include /usr/share/cdbs/1/rules/utils.mk
-include /usr/share/cdbs/1/rules/debhelper.mk
-include /usr/share/cdbs/1/class/autotools.mk
 
 # source equivalent of nodejs -e 'console.log(process.versions.modules)'
 ABI = $(shell awk '/^\#define NODE_MODULE_VERSION/ {print $$3}' src/node_version.h)
@@ -26,42 +11,6 @@
 # branch
 BRANCH := $(word 1, $(subst .,$(space), $(DEB_UPSTREAM_VERSION)))
 
-# Build-depend unversioned on debhelper
-#  TODO: Drop when adopted in cdbs
-CDBS_BUILD_DEPENDS_rules_debhelper_v9 = debhelper (>=9.20160114)
-
-# Do not install licensecheck please
-CDBS_BUILD_DEPENDS_rules_utils_copyright-check =
-
-# Needed by upstream build
-#  * recent gyp needed to build using flock
-bdeps = pkg-config, bash-completion, libkvm-dev [kfreebsd-any], gyp (>= 0.1~svn1773)
-bdeps +=, openssl (>= 1.1.1~)
-bdeps +=, zlib1g-dev
-bdeps +=, libicu-dev (>= 64.0~)
-bdeps +=, libc-ares-dev (>= 1.14~)
-bdeps +=, libnghttp2-dev (>= 1.39.1~)
-# bdeps +=, libhttp-parser-dev (>= 2.8~)
-
-# Needed by dev
-devdeps = libssl-dev (>= 1.1.1~)
-devdeps +=, libuv1-dev (>= 1.30.1~)
-
-# Needed for tests
-bdeps +=, curl, procps,
-bdeps +=, node-debbundle-acorn (>= 6.1.0~)
-bdeps +=, ca-certificates
-bdeps +=, python
-
-CDBS_BUILD_DEPENDS +=, $(bdeps), $(deps), $(devdeps)
-CDBS_DEPENDS_libnode-dev = $(devdeps)
-
-CDBS_RECOMMENDS_nodejs = ca-certificates
-CDBS_BREAKS_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev
-CDBS_BREAKS_libnode$(ABI) = node-modern-syslog (<< 1.1.4-2)
-CDBS_REPLACES_libnode-dev = nodejs-dev (<< 10.0.0~dfsg1-3), libnode64-dev, libv8-dev
-CDBS_PROVIDES_libnode-dev = libv8-dev
-CDBS_CONFLICTS_libnode-dev = libv8-dev (<= 3.14.5.8-11)
 LANG=C
 export LANG
 DEB_CONFIGURE_NORMAL_ARGS =
@@ -70,7 +19,8 @@
 --shared \
 --shared-zlib \
 --shared-cares \
---shared-nghttp2 --shared-nghttp2-libname=nghttp2 \
+--shared-nghttp2 \
+--shared-brotli \
 --with-intl=system-icu \
 --prefix=/usr \
 --openssl-use-def-ca-store \
@@ -82,7 +32,6 @@
 
 # map HOST ARCH AND OS, and if unknown let upstream guess
 
-# ia32 x64 x32 arm arm64 mips mipsel mips64el x87 ppc ppc64
 destCpu =
 destCpu := $(or $(destCpu),$(if $(filter i386,$(DEB_HOST_ARCH)),ia32))
 destCpu := $(or $(destCpu),$(if $(filter x32,$(DEB_HOST_ARCH)),x32))
@@ -131,13 +80,11 @@
 # https://lists.debian.org/debian-mips/2016/07/msg00000.html
 ifeq (mipsel, $(DEB_HOST_ARCH))
 DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
-LDFLAGS += -latomic
 CFLAGS += -gsplit-dwarf
 CPPFLAGS += -gsplit-dwarf
 endif
 ifeq (mips, $(DEB_HOST_ARCH))
 DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=r2 --with-mips-fpu-mode=fpxx
-LDFLAGS += -latomic
 CFLAGS += -gsplit-dwarf
 CPPFLAGS += -gsplit-dwarf
 endif
@@ -145,9 +92,13 @@
 # mips32r1 or greater, detected at runtime
 ifeq (mips64el, $(DEB_HOST_ARCH))
 DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
+CFLAGS += -gsplit-dwarf
+CPPFLAGS += -gsplit-dwarf
 endif
 ifeq (mips64r6el, $(DEB_HOST_ARCH))
 DEB_CONFIGURE_EXTRA_FLAGS += --with-mips-arch-variant=rx --with-mips-fpu-mode=fp64
+CFLAGS += -gsplit-dwarf
+CPPFLAGS += -gsplit-dwarf
 endif
 
 ifeq (armel, $(DEB_HOST_ARCH))
@@ -176,14 +127,6 @@
 
 DEB_DESTDIR = $(CURDIR)/debian/tmp
 DEB_MAKE_CLEAN_TARGET = clean
-ifeq ($(DEB_PARALLEL_JOBS),)
-JOBS := 1
-else ifeq ($(SCHROOT_USER),"buildd")
-JOBS := 1
-else
-JOBS := $(DEB_PARALLEL_JOBS)
-endif
-export JOBS
 DEB_MAKE_BUILD_TARGET = build
 
 #  relax regression tests when targeted experimental suite
@@ -192,6 +135,7 @@
 export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
 export CI_JS_SUITES = message parallel sequential
 export NODE_TEST_DIR = $(CURDIR)/tmp
+export PYTHON = python2
 # needed for tests to avoid "ee key too small" errors
 export OPENSSL_CONF = ./deps/openssl/openssl/apps/openssl.cnf
 # keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
@@ -199,12 +143,23 @@
 DEB_MAKE_CHECK_TARGET = $(exp-relax-check) test-ci-js
 
 # build -fPIC
-CFLAGS+=-fPIC
-CPPFLAGS+=-fPIC
+CFLAGS += -fPIC
+CPPFLAGS += -fPIC
+
+ifeq ($(DEB_HOST_ARCH_BITS),32)
+CFLAGS += -g1
+CPPFLAGS += -g1
+DH_FLAGS += --max-parallel=1
+export JOBS = 1
+else
+CFLAGS += -g
+CPPFLAGS += -g
+endif
+
+
 # hardening gyp
-CFLAGS+=-g
-CPPFLAGS+=-g
-CXXFLAGS+=$(CPPFLAGS)
+CXXFLAGS += $(CPPFLAGS)
+
 export CPPFLAGS
 export CXXFLAGS
 export CFLAGS
@@ -213,8 +168,12 @@
 # disable DNS requests during tests
 export RES_OPTIONS = attempts:0
 
+%:
+	dh $@ $(DH_FLAGS)
+
 # properly clean files from build, test, python
-clean::
+override_dh_auto_clean:
+	dh_auto_clean
 	rm -f icu_config.gypi
 	rm -rf test/addons/doc-*
 	rm -f test/addons/.buildstamp
@@ -225,8 +184,6 @@
 	rm -f config.status
 	rm -f test/fixtures/hello.txt
 	rm -rf $(NODE_TEST_DIR)
-	rm -f node_modules
-	rm -rf tools/node_modules
 	find . -name "*.pyc" -delete
 	rm -rf out
 	rm -rf deps/acorn/
@@ -234,8 +191,48 @@
 	rm -f debian/libnode-dev.links
 
 # remove *.json files from documentation
-binary-install/nodejs-doc::
-	find debian/nodejs-doc/usr/share/doc/nodejs-doc -name *.json -delete
-
-pre-build::
-	ln -sTf /usr/lib/nodejs node_modules
+override_dh_installdocs:
+	dh_installdocs
+	find debian/nodejs-doc/usr/share/doc/nodejs-doc -name *.json -delete || true
+
+override_dh_auto_configure:
+	./configure $(DEB_CONFIGURE_EXTRA_FLAGS)
+
+override_dh_auto_build-arch:
+	mkdir -p $(NODE_TEST_DIR)
+	mkdir -p deps/acorn/
+	ln -sTf $(shell nodepath acorn) deps/acorn/acorn
+	ln -sTf $(shell nodepath acorn-walk) deps/acorn/acorn-walk
+	dh_auto_build
+
+override_dh_auto_build-indep:
+	NODE_PATH=/usr/share/nodejs:/usr/lib/nodejs $(MAKE) doc-only
+
+override_dh_auto_test-indep:
+	# skip tests
+
+override_dh_auto_test-arch:
+	$(MAKE) test-ci-js
+
+override_dh_auto_install-indep:
+	# skip install all
+
+override_dh_auto_install-arch:
+	dh_auto_install
+
+override_dh_install-arch:
+	sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' debian/libnode.install > debian/libnode$(ABI).install
+	sed -e 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' -e 's/@ABI@/$(ABI)/g' debian/libnode-dev.links.in > debian/libnode-dev.links
+	dh_install
+
+override_dh_dwz:
+	# Double up the limit of debug information entries
+	# Also, ignore failures (on 32-bit archs it might fail)
+	-dh_dwz -- --max-die-limit 100000000
+
+check:
+	-ln -s /usr/bin/node node
+	mkdir -p $(NODE_TEST_DIR)
+	$(MAKE) $(DEB_MAKE_CHECK_TARGET)
+	rm -f node
+	rm -rf $(NODE_TEST_DIR)

=== debian/watch ===
version=3
opts=downloadurlmangle=s/.*v(.*)\//https\:\/\/nodejs\.org\/dist\/v$1\/node\-v$1\.tar\.xz/,\
filenamemangle=s/.*v(.*)\/$/nodejs-$1\.tar\.xz/,\
dversionmangle=s/~dfsg\d*$//,\
repacksuffix=~dfsg \
https://nodejs.org/dist v(12\.\d+\.\d+)/

## nodejs 12.19.0~dfsg

=== debian/changelog ===
nodejs (12.19.0~dfsg-1) unstable; urgency=medium

  * New upstream version 12.19.0~dfsg (Closes: #968681)
  * Refresh patches

 -- Jérémy Lal <kapouer@melix.org>  Wed, 07 Oct 2020 00:32:42 +0200

nodejs (12.18.4~dfsg-1) unstable; urgency=high

  * New upstream version 12.18.4~dfsg
    Vulnerabilities fixed:
    + CVE-2020-8201
      HTTP Request Smuggling due to CR-to-Hyphen conversion (High)
    + CVE-2020-8252
      fs.realpath.native on may cause buffer overflow (Medium)

 -- Jérémy Lal <kapouer@melix.org>  Wed, 16 Sep 2020 14:59:04 +0200

nodejs (12.18.3~dfsg-4) unstable; urgency=medium

  * python3 patch: use env.PYTHON in two tests
    Closes: #967032 for good.

 -- Jérémy Lal <kapouer@melix.org>  Sat, 08 Aug 2020 14:09:43 +0200

nodejs (12.18.3~dfsg-3) unstable; urgency=medium

  * export PYTHON = python3 for Makefile

 -- Jérémy Lal <kapouer@melix.org>  Fri, 07 Aug 2020 03:33:58 +0200

nodejs (12.18.3~dfsg-2) unstable; urgency=medium

  * tests/control: depends python3, python3-distutils, drop cdbs
    Thanks Moritz Mühlenhoff for noticing that.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 05 Aug 2020 10:40:31 +0200

nodejs (12.18.3~dfsg-1) unstable; urgency=medium

  * New upstream version 12.18.3~dfsg
  * B-D python3, python3-distutils
    patch configure to use python3 (Closes: #967032)
  * nodejs-doc: depends libjs-highlight.js
  * copyright: dfsg-exclude highlight.pack.js,
    replace sh_javascript.min.js
  * source/lintian-overrides: drop sh_javascript.min.js override
  * Drop patch that restores unminified sh_javascript.min.js
  * Update make-doc.patch to deal with new syntax in esm.md

 -- Jérémy Lal <kapouer@melix.org>  Wed, 05 Aug 2020 00:11:08 +0200

=== debian/control ===
--- 
+++ 
@@ -23,7 +23,8 @@
  openssl (>= 1.1.1~),
  pkg-config,
  pkg-js-tools (>= 0.8.2~),
- python2,
+ python3,
+ python3-distutils,
  procps,
  zlib1g-dev,
 Build-Depends-Indep: node-js-yaml,
@@ -111,6 +112,7 @@
 Multi-Arch: foreign
 Recommends: nodejs
 Depends: ${misc:Depends}
+ , libjs-highlight.js
 Replaces: nodejs (<< 6.11.2~dfsg-3)
 Conflicts: nodejs (<< 6.11.2~dfsg-3)
 Description: API documentation for Node.js, the javascript platform

=== debian/rules ===
--- 
+++ 
@@ -135,7 +135,6 @@
 export TEST_CI_ARGS = --arch=$(destCpu) --timeout=3000
 export CI_JS_SUITES = message parallel sequential
 export NODE_TEST_DIR = $(CURDIR)/tmp
-export PYTHON = python2
 # needed for tests to avoid "ee key too small" errors
 export OPENSSL_CONF = ./deps/openssl/openssl/apps/openssl.cnf
 # keep in mind ./debian/rules check is also invoked by adt-run, see debian/tests/
@@ -164,6 +163,8 @@
 export CXXFLAGS
 export CFLAGS
 export LDFLAGS
+
+export PYTHON = python3
 
 # disable DNS requests during tests
 export RES_OPTIONS = attempts:0
